c   program to process all of the input data from file for ramabs

      subroutine inram(ifile, nmode, nline, ntime, nstep, sig, temp, e0,
     1 gamma,rkappa,u,alow,ahigh,delt, refrac,wg,delta,nquanta,lb,
     2 ub, abs_weight, raman_weight, alife)
 
	character*100 ifile
      real*8 nmode, nline, ntime, nstep, nquanta(40,30), refrac
	real*8 sig, temp, e0, gamma, rkappa, u, alife, alow, ahigh, delt
	real*8 wg(30),delta(30), lb(35), ub(35)
	real*8 abs_weight, raman_weight

	integer eof

      open(unit=30,name=ifile,type='old')
      read (30,*,iostat = eof) nmode,nline,ntime,nstep
	if (eof .lt. 0 ) then
		call mexErrMsgTxt('Error in first line')
	endif
      read (30,*,iostat = eof) sig,temp
	if (eof .lt. 0 ) then
		call mexErrMsgTxt('Error in second line')
	endif
      if(nmode.gt.30) nmode=30
      if(nline.gt.40) nline=40
	if(ntime.gt.5000) ntime=5000
	if(nstep.gt.1000) nstep=1000
	read (30,*,iostat = eof) e0,gamma,rkappa,u,alife
	if (eof .lt. 0 ) then
		call mexErrMsgTxt('Error in third line')
	endif
      read (30,*,iostat = eof) alow,ahigh,delt,refrac
	if (eof .lt. 0 ) then
		call mexErrMsgTxt('Error in fourth line')
	endif
	read (30,*,iostat = eof) abs_weight,raman_weight
	if (eof .lt. 0 ) then
		call mexErrMsgTxt('Error in five line')
	endif
      read (30,*,iostat = eof) lb(1),lb(2),lb(3),lb(4),lb(5),lb(6)
	if (eof .lt. 0 ) then
		call mexErrMsgTxt('Error: Too many or too few lower bounds')
	endif
      read (30,*,iostat = eof) ub(1),ub(2),ub(3),ub(4),ub(5),ub(6)
	if (eof .lt. 0 ) then
		call mexErrMsgTxt('Error: Too many or too few upper bounds')
	endif
      do i = 7,(nmode + 5)
        lb(i) = lb(6)
        ub(i) = ub(6)
      end do
	read (30,*,iostat = eof) (wg(i),delta(i),i=1,nmode)
	if (eof .lt. 0 ) then
		call mexErrMsgTxt('Error in delta lines')
	endif
      do 40 i=1,nline
 40       read (30,*,iostat = eof) (nquanta(i,j),j=1,nmode)
		if (eof .lt. 0 ) then
			call mexErrMsgTxt('Error in quantas line')
		endif
      close(unit=30)

      end subroutine

      subroutine mexFunction(nlhs, plhs, nrhs, prhs)
c
c	function to export ramabs() to Matlab
c
c	Might in the future use this function to be the automater....
c
c	nlhs is the number of expected ouputs
c	plhs is the Array of pointers to outputs
c	nrhs is the number of inputs
c	prhs is the Array of pointers to inputs

c	implicit none

	integer mxGetM, mxGetN, mxGetPr, mxIsNumeric, mxIsChar
      integer mxCreateDoubleMatrix
	integer mxCreateString, mxGetString
	integer plhs(*), prhs(*)
	integer nlhs, nrhs, m, n, size
	integer  status, strlen
c   input variables
      character*100 ifile

c	output variables
	real*8 nmode, nline, ntime, nstep, nquanta(40,30), refrac
	real*8 sig, temp, e0, gamma, rkappa, u, alife, alow, ahigh, delt
	real*8 wg(30),delta(30), lb(34), ub(34), abs_weight, raman_weight

c   input pointers
      integer*8 ifile_ptr

c	output pointers

	integer*8 nmode_ptr, nline_ptr, ntime_ptr, nstep_ptr, nquanta_ptr
	integer*8 sig_ptr, temp_ptr, e0_ptr, gamma_ptr, rkappa_ptr, u_ptr
      integer*8 alife_ptr
	integer*8 alow_ptr, ahigh_ptr, delt_ptr, refrac_ptr
	integer*8 wg_ptr, delta_ptr, lb_ptr, ub_ptr
	integer*8 raman_weight_ptr,  abs_weight_ptr

C     Check for proper number of arguments.
      if(nrhs .ne. 1) then
        call mexErrMsgTxt('Only 1 input required.')
      elseif(nlhs .ne. 22) then
         call mexErrMsgTxt('22 outputs required.')

c	input must be a string
	elseif(mxIsChar(prhs(1)) .ne. 1) then
         call mexErrMsgTxt('Input must be a string.')

C     The input must be a row vector.
      elseif (mxGetM(prhs(1)) .ne. 1) then
         call mexErrMsgTxt('Input must be a row vector.')
      endif
	
C     Get the length of the input string.
      strlen = mxGetM(prhs(1))*mxGetN(prhs(1))

C     Get the string contents (dereference the input integer).
      status = mxGetString(prhs(1), ifile, 100)

C     Check if mxGetString is successful.
      if (status .ne. 0) then
         call mexErrMsgTxt('String length must be less than 100.')
      endif

       call inram(ifile, nmode, nline, ntime, nstep, sig, temp, e0,
     1 gamma,rkappa,u,alow,ahigh,delt, refrac,wg,delta,nquanta,lb,
     2 ub, abs_weight, raman_weight, alife)


      size = 1
      plhs(1) = mxCreateDoubleMatrix(1,1, 0)
      nmode_ptr = mxGetPr(plhs(1))
      call mxCopyReal8ToPtr(nmode, nmode_ptr, size)

      plhs(2) = mxCreateDoubleMatrix(1,1, 0)
      nline_ptr = mxGetPr(plhs(2))
      call mxCopyReal8ToPtr(nline, nline_ptr, size)

      plhs(3) = mxCreateDoubleMatrix(1,1, 0)
      ntime_ptr = mxGetPr(plhs(3))
      call mxCopyReal8ToPtr(ntime, ntime_ptr, size)

      plhs(4) = mxCreateDoubleMatrix(1,1, 0)
      nstep_ptr = mxGetPr(plhs(4))
      call mxCopyReal8ToPtr(nstep, nstep_ptr, size)

      plhs(5) = mxCreateDoubleMatrix(1,1, 0)
      sig_ptr = mxGetPr(plhs(5))
      call mxCopyReal8ToPtr(sig, sig_ptr, size)

      plhs(6) = mxCreateDoubleMatrix(1,1, 0)
      temp_ptr = mxGetPr(plhs(6))
      call mxCopyReal8ToPtr(temp, temp_ptr, size)

      plhs(7) = mxCreateDoubleMatrix(1,1, 0)
      e0_ptr = mxGetPr(plhs(7))
      call mxCopyReal8ToPtr(e0, e0_ptr, size)

      plhs(8) = mxCreateDoubleMatrix(1,1, 0)
      gamma_ptr = mxGetPr(plhs(8))
      call mxCopyReal8ToPtr(gamma, gamma_ptr, size)

      plhs(9) = mxCreateDoubleMatrix(1,1, 0)
      rkappa_ptr = mxGetPr(plhs(9))
      call mxCopyReal8ToPtr(rkappa, rkappa_ptr, size)

      plhs(10) = mxCreateDoubleMatrix(1,1, 0)
      u_ptr = mxGetPr(plhs(10))
      call mxCopyReal8ToPtr(u, u_ptr, size)

      plhs(11) = mxCreateDoubleMatrix(1,1, 0)
      alow_ptr = mxGetPr(plhs(11))
      call mxCopyReal8ToPtr(alow, alow_ptr, size)

      plhs(12) = mxCreateDoubleMatrix(1,1, 0)
      ahigh_ptr = mxGetPr(plhs(12))
      call mxCopyReal8ToPtr(ahigh, ahigh_ptr, size)

      plhs(13) = mxCreateDoubleMatrix(1,1, 0)
      delt_ptr = mxGetPr(plhs(13))
      call mxCopyReal8ToPtr(delt, delt_ptr, size)

      plhs(14) = mxCreateDoubleMatrix(1,1, 0)
      refrac_ptr = mxGetPr(plhs(14))
      call mxCopyReal8ToPtr(refrac, refrac_ptr, size)

      plhs(15) = mxCreateDoubleMatrix(30,1, 0)
      wg_ptr = mxGetPr(plhs(15))
      size = 30
      call mxCopyReal8ToPtr(wg, wg_ptr, size)

      plhs(16) = mxCreateDoubleMatrix(30,1, 0)
      delta_ptr = mxGetPr(plhs(16))
      size = 30
      call mxCopyReal8ToPtr(delta, delta_ptr, size)


      plhs(17) = mxCreateDoubleMatrix(40,30, 0)
      nquanta_ptr = mxGetPr(plhs(17))
      size = 30*40
      call mxCopyReal8ToPtr(nquanta, nquanta_ptr, size)

	size = 5 + nmode
      plhs(18) = mxCreateDoubleMatrix(size,1, 0)
      lb_ptr = mxGetPr(plhs(18))
      call mxCopyReal8ToPtr(lb, lb_ptr, size)

      plhs(19) = mxCreateDoubleMatrix(size,1, 0)
      ub_ptr = mxGetPr(plhs(19))
      call mxCopyReal8ToPtr(ub, ub_ptr, size)

	plhs(20) = mxCreateDoubleMatrix(1,1,0)
	abs_weight_ptr = mxGetPr(plhs(20))
	call mxCopyReal8ToPtr(abs_weight, abs_weight_ptr, 1)

	plhs(21) = mxCreateDoubleMatrix(1,1,0)
	raman_weight_ptr = mxGetPr(plhs(21))
	call mxCopyReal8ToPtr(raman_weight, raman_weight_ptr, 1)

      plhs(22) = mxCreateDoubleMatrix(1,1,0)
	alife_ptr = mxGetPr(plhs(22))
	call mxCopyReal8ToPtr(alife, alife_ptr, 1)

      end subroutine


